"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const taskId_1 = require("../task/taskId");
const generateTask_1 = require("../task/generateTask");
exports.ComputeHashTask = "??computeHash";
exports.CacheFetchTask = "??fetch";
exports.CachePutTask = "??put";
function generateCacheTasks(context) {
    const { allPackages, tasks, taskDepsGraph } = context;
    for (const pkg of Object.keys(allPackages)) {
        const hashTaskId = taskId_1.getTaskId(pkg, exports.ComputeHashTask);
        tasks.set(hashTaskId, () => generateTask_1.generateTask(hashTaskId, context));
        const fetchTaskId = taskId_1.getTaskId(pkg, exports.CacheFetchTask);
        tasks.set(fetchTaskId, () => generateTask_1.generateTask(fetchTaskId, context));
        const putTaskId = taskId_1.getTaskId(pkg, exports.CachePutTask);
        tasks.set(putTaskId, () => generateTask_1.generateTask(hashTaskId, context));
        taskDepsGraph.push([hashTaskId, fetchTaskId]);
    }
    for (const taskId of tasks.keys()) {
        const [pkg, task] = taskId_1.getPackageTaskFromId(taskId);
        if (task !== exports.CacheFetchTask &&
            task !== exports.CachePutTask &&
            task !== exports.ComputeHashTask) {
            const fetchTaskId = taskId_1.getTaskId(pkg, exports.CacheFetchTask);
            const putTaskId = taskId_1.getTaskId(pkg, exports.CachePutTask);
            // set up the graph
            taskDepsGraph.push([fetchTaskId, taskId]);
            taskDepsGraph.push([taskId, putTaskId]);
        }
    }
}
exports.generateCacheTasks = generateCacheTasks;
