"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const getPackageInfos_1 = require("./monorepo/getPackageInfos");
const discoverTaskDeps_1 = require("./task/discoverTaskDeps");
const taskRunner_1 = require("./task/taskRunner");
const profiler_1 = __importDefault(require("@lerna/profiler"));
const os_1 = __importDefault(require("os"));
const dist_1 = __importDefault(require("p-queue/dist"));
const concurrency = os_1.default.cpus().length - 1;
const context = {
    allPackages: getPackageInfos_1.getPackageInfos(process.cwd()),
    command: "ut",
    concurrency,
    defaultPipeline: {
        clean: [],
        rebuild: ["clean", "build"],
        build: ["^build"],
        ut: ["build"],
    },
    taskDepsGraph: [],
    tasks: new Map(),
    packageScope: [],
    measures: [],
    profiler: new profiler_1.default({
        concurrency,
        outputDirectory: process.cwd(),
    }),
    taskLogs: new Map(),
    queue: new dist_1.default({ concurrency }),
    taskStats: new Map(),
    cache: true,
};
discoverTaskDeps_1.discoverTaskDeps(context);
taskRunner_1.runTasks(context);
