"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ansi_diff_1 = __importDefault(require("ansi-diff"));
const diff = ansi_diff_1.default({
    // if you want to support word wrapping, provide the terminal width
    width: process.stdout.columns,
});
function reportTaskLog(taskId, message, context) {
    var _a;
    if (!context.taskLogs.has(taskId)) {
        context.taskLogs.set(taskId, []);
    }
    (_a = context.taskLogs.get(taskId)) === null || _a === void 0 ? void 0 : _a.push(message);
    if (message) {
        process.stdout.write(`${taskId}: ${message.trim()}\n`);
    }
    //renderTaskLogs(context);
}
exports.reportTaskLog = reportTaskLog;
function renderTaskLogs(context) {
    const logs = context.taskLogs;
    process.stdout.write(diff.update(`${[...logs.entries()]
        .map(([taskId, lines]) => {
        return `--- ${taskId} ---\n${lines
            .map((line) => `  ${line}`)
            .join("\n")}`;
    })
        .join("\n")}`));
}
exports.renderTaskLogs = renderTaskLogs;
