"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const taskId_1 = require("./taskId");
const backfill_1 = require("../cache/backfill");
const performance_1 = require("../performance");
async function taskWrapper(taskId, fn, context) {
    const { allPackages, profiler, taskStats } = context;
    const [pkg, task] = taskId_1.getPackageTaskFromId(taskId);
    performance_1.markStart(taskId);
    if (!backfill_1.cacheHits[taskId]) {
        await profiler.run(() => fn(allPackages[pkg], context), taskId);
        taskStats.set(pkg, {});
        await backfill_1.putBackfill(allPackages[pkg]);
    }
    performance_1.markEnd(taskId);
}
exports.taskWrapper = taskWrapper;
